package com.gxwebsoft.apps.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.apps.service.HualalaCardService;
import com.gxwebsoft.apps.entity.HualalaCard;
import com.gxwebsoft.apps.param.HualalaCardParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 控制器
 *
 * @author 科技小王子
 * @since 2023-01-08 12:22:50
 */
@Api(tags = "管理")
@RestController
@RequestMapping("/api/apps/hualala-card")
public class HualalaCardController extends BaseController {
    @Resource
    private HualalaCardService hualalaCardService;

    @PreAuthorize("hasAuthority('apps:hualalaCard:list')")
    @OperationLog
    @ApiOperation("分页查询")
    @GetMapping("/page")
    public ApiResult<PageResult<HualalaCard>> page(HualalaCardParam param) {
        PageParam<HualalaCard, HualalaCardParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaCardService.page(page, page.getWrapper()));
        // 使用关联查询
        //return success(hualalaCardService.pageRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:list')")
    @OperationLog
    @ApiOperation("查询全部")
    @GetMapping()
    public ApiResult<List<HualalaCard>> list(HualalaCardParam param) {
        PageParam<HualalaCard, HualalaCardParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(hualalaCardService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(hualalaCardService.listRel(param));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:list')")
    @OperationLog
    @ApiOperation("根据id查询")
    @GetMapping("/{id}")
    public ApiResult<HualalaCard> get(@PathVariable("id") Integer id) {
        return success(hualalaCardService.getById(id));
        // 使用关联查询
        //return success(hualalaCardService.getByIdRel(id));
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:save')")
    @OperationLog
    @ApiOperation("添加")
    @PostMapping()
    public ApiResult<?> save(@RequestBody HualalaCard hualalaCard) {
        // 记录当前登录用户id、租户id、商户编号
        User loginUser = getLoginUser();
        if (loginUser != null) {
          hualalaCard.setUserId(loginUser.getUserId());
          hualalaCard.setMerchantCode(getMerchantCode());
        }
        if (hualalaCardService.save(hualalaCard)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:update')")
    @OperationLog
    @ApiOperation("修改")
    @PutMapping()
    public ApiResult<?> update(@RequestBody HualalaCard hualalaCard) {
        if (hualalaCardService.updateById(hualalaCard)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:remove')")
    @OperationLog
    @ApiOperation("删除")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (hualalaCardService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:save')")
    @OperationLog
    @ApiOperation("批量添加")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<HualalaCard> list) {
        if (hualalaCardService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:update')")
    @OperationLog
    @ApiOperation("批量修改")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<HualalaCard> batchParam) {
        if (batchParam.update(hualalaCardService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @PreAuthorize("hasAuthority('apps:hualalaCard:remove')")
    @OperationLog
    @ApiOperation("批量删除")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (hualalaCardService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
